package com.platega.memoriae;


import android.app.Activity;
import android.app.AlertDialog;
import android.app.Dialog;
import android.content.DialogInterface;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.os.Bundle;
import android.os.CountDownTimer;
import android.util.Log;
import android.view.Menu;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.animation.Animation;
import android.view.animation.Animation.AnimationListener;
import android.view.animation.AnimationUtils;
import android.widget.ImageView;
import android.widget.TableLayout;
import android.widget.TableRow;
import android.widget.TextView;

import com.platega.memoriae.loxica.Imaxe;
import com.platega.memoriae.loxica.LoxicaXogoParellas;

public class ActivityParellas extends Activity {

	public static CountDownTimer crono;

	/**
	 * Inicializa o crono
	 */
	private void inicializarXogoParellas() {

		final TextView tvCrono = (TextView) findViewById(R.id.lblParellasCrono);

		// INCIALIZAMOS O CRONO
		crono = new CountDownTimer(LoxicaXogoParellas.TEMPO_CRONO, 1000) {
			public void onTick(long millisUntilFinished) {
				tvCrono.setText(String.valueOf(millisUntilFinished / 1000));

			}

			public void onFinish() {
				Log.i("MEMORIAE", "ACABOUSE");
				ActivityParellas.this.finish();

			}
		}.start();

		
		// Agora debemos cargar o array de imaxes coas imaxes que empecen por
		// parellaXX
		int figuras = LoxicaXogoParellas.getNumFilasXogoParellas()
				* LoxicaXogoParellas.getNumColumnasXogoParellas();

		int numFilas = LoxicaXogoParellas.getNumFilasXogoParellas();
		int numColumnas = LoxicaXogoParellas.getNumColumnasXogoParellas();

		Imaxe imaxe1 = new Imaxe(0), imaxe2 = new Imaxe(0); // Para gardar no
															// array
		LoxicaXogoParellas.imaxes = new Imaxe[numFilas][numColumnas]; // Inicializamos
																		// o
																		// array
																		// coas
																		// imaxes

		// Gardamos as imaxes no array
		for (int cont = 0; cont < figuras / 2; cont++) {

			int imaxeid = getResources().getIdentifier("parella" + cont,
					"drawable", getPackageName());
			imaxe1 = new Imaxe(imaxeid);
			imaxe2 = new Imaxe(imaxeid);

			// A imaxe colócase dúas veces de forma aleatoria
			int aleatorioFila, aleatorioColumna;
			do {
				aleatorioFila = LoxicaXogoParellas.xerarAleatorio(0, numFilas);
				aleatorioColumna = LoxicaXogoParellas.xerarAleatorio(0,
						numColumnas);

			} while (LoxicaXogoParellas.imaxes[aleatorioFila][aleatorioColumna] != null);
			LoxicaXogoParellas.imaxes[aleatorioFila][aleatorioColumna] = imaxe1;

			do {
				aleatorioFila = LoxicaXogoParellas.xerarAleatorio(0, numFilas);
				aleatorioColumna = LoxicaXogoParellas.xerarAleatorio(0,
						numColumnas);

			} while (LoxicaXogoParellas.imaxes[aleatorioFila][aleatorioColumna] != null);
			LoxicaXogoParellas.imaxes[aleatorioFila][aleatorioColumna] = imaxe2;

		}

		LoxicaXogoParellas.parellasatopadas.clear();
	}
	
	
	/**
	 * Dialogo que aparece cando remato o xogo e non se tivo unha boa puntuación.
	 */
	

	/**
	 * Crea filas e columnas en función do grao de dificultade escollido en
	 * preferencias. Agrega as animacións e controla que non se poidan dar a
	 * volta máis de dúas imaxes.
	 */
	private void axustarGradoDificultade() {
		final int filas;
		final int columnas;

		filas = LoxicaXogoParellas.getNumFilasXogoParellas();
		columnas = LoxicaXogoParellas.getNumColumnasXogoParellas();

		final TableLayout tabla = (TableLayout) findViewById(R.id.ParellasTableLayoutGraficos);
		tabla.removeAllViewsInLayout();
		for (int cont1 = 0; cont1 < filas; cont1++) { // FILAS
			TableRow taboaFila = new TableRow(this);

			tabla.addView(taboaFila);
			for (int cont2 = 0; cont2 < columnas; cont2++) { // COLUMNAS
				ImageView img = new ImageView(this);
				img.setTag(LoxicaXogoParellas.imaxes[cont1][cont2]); // Gardamos
																		// o
																		// obxecto
																		// image
																		// do
																		// array
				img.setImageResource(R.drawable.question);
				img.setOnClickListener(new OnClickListener() {

					@Override
					public void onClick(View v) {

						if (LoxicaXogoParellas.parellaslevantadas[1] != null) // Hai
																				// dúas
																				// levantadas.
							return;

						final ImageView imx = (ImageView) v;
						Imaxe imaxe = (Imaxe) imx.getTag();
						if (LoxicaXogoParellas.parellasatopadas.contains(imaxe)) { // Imaxe
																					// xa
																					// levantada
							return; // Xa atopada
						}

						if (imaxe.getTarxeta()) {
							try {
								Bitmap bitmap = BitmapFactory.decodeFile(imaxe
										.getNome());
								imx.setImageBitmap(bitmap);

							} catch (Exception e) {
								// TODO Auto-generated catch block
								Log.e("MEMORIAE", e.getMessage());
							}

						} else
							imx.setImageResource(imaxe.get_id());

						Animation fundido = AnimationUtils.loadAnimation(
								getApplicationContext(),
								R.anim.animacion_aparece_do_fundido);
						fundido.setAnimationListener(new AnimationListener() {

							@Override
							public void onAnimationStart(Animation animation) {
								// TODO Auto-generated method stub

							}

							@Override
							public void onAnimationRepeat(Animation animation) {
								// TODO Auto-generated method stub

							}

							@Override
							public void onAnimationEnd(Animation animation) {
								// TODO Auto-generated method stub

								if (LoxicaXogoParellas.parellaslevantadas[1] != null) { // Hai
																						// duas
																						// levantadas
									Imaxe imaxe1 = LoxicaXogoParellas.parellaslevantadas[0];
									Imaxe imaxe2 = LoxicaXogoParellas.parellaslevantadas[1];

									if (imaxe1.get_id() == imaxe2.get_id()) {
										// Descubriu a parella
										LoxicaXogoParellas.parellasatopadas
												.add(LoxicaXogoParellas.parellaslevantadas[0]);
										LoxicaXogoParellas.parellasatopadas
												.add(LoxicaXogoParellas.parellaslevantadas[1]);
										if (LoxicaXogoParellas.parellasatopadas.size()==LoxicaXogoParellas.getNumColumnasXogoParellas()*LoxicaXogoParellas.getNumFilasXogoParellas()){
											// Rematou o xogo
										crono.cancel();
										showDialog(0);
											
										}
										
									} else {
										// Voltamos as dúas imaxes a imaxe
										// inicial e limpamos
										ImageView imaxe_1 = (ImageView) tabla
												.findViewWithTag(LoxicaXogoParellas.parellaslevantadas[0]);
										imaxe_1.setImageResource(R.drawable.question);
										ImageView imaxe_2 = (ImageView) tabla
												.findViewWithTag(LoxicaXogoParellas.parellaslevantadas[1]);
										imaxe_2.setImageResource(R.drawable.question);
									}
									LoxicaXogoParellas.parellaslevantadas[0] = LoxicaXogoParellas.parellaslevantadas[1] = null;

								}
							}
						});
						v.startAnimation(fundido);
						LoxicaXogoParellas.engadirImaxeLevantada(imaxe);
					}
				});
				taboaFila.addView(img);
			}

		}
	}

	/**
	 * Dialogo que aparece cando remato o xogo e non se tivo unha boa
	 * puntuación.
	 */
	@Override
	protected Dialog onCreateDialog(int id) {

		switch (id) { // So temos un diálogo, non faría falla
		case 0:
			return new AlertDialog.Builder(this)
					.setIcon(R.drawable.animacion_terra)
					.setTitle(R.string.parellas_dialogo_titulo)
					.setPositiveButton(
							R.string.parellas_diailogo_boton_aceptar,
							new DialogInterface.OnClickListener() {

								@Override
								public void onClick(DialogInterface arg0,
										int arg1) {
									// TODO Auto-generated method stub
									inicializarXogoParellas();
									axustarGradoDificultade();
								}

							}).create();
		}
		return null;

	}

	@Override
	public void onStart() {
		super.onStart();
		inicializarXogoParellas();
		axustarGradoDificultade();
	}

	@Override
	public void onStop() {
		super.onStop();
		crono.cancel();
	}

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_parellas);

	}

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		// Inflate the menu; this adds items to the action bar if it is present.
		getMenuInflater().inflate(R.menu.parellas, menu);
		return true;
	}

}
