package com.platega.memoriae;

import android.app.Activity;
import android.content.Context;
import android.content.Intent;
import android.os.Bundle;
import android.view.Menu;
import android.view.View;
import android.widget.Toast;

public class ActivityPrincipal extends Activity {

	/**
	 * Amosa unha mensaxe
	 * 
	 * @param contexto
	 *            : contexto da aplicación
	 * @param id
	 *            : identifica a cadea dentro do arquivo strings a amosar
	 */
	public static void amosarMensaxe(Context contexto, int id) {
		String mensaxe;
		mensaxe = contexto.getResources().getString(id);
		Toast.makeText(contexto.getApplicationContext(), mensaxe,
				Toast.LENGTH_SHORT).show();
	}

	/**
	 * Amosa unha mensaxe
	 * 
	 * @param contexto
	 *            : contexto da aplicación
	 * @param id
	 *            : identifica a cadea dentro do arquivo strings a amosar
	 * @param valor
	 *            : cadea a substuír na mensaxe
	 */
	public static void amosarMensaxe(Context contexto, int id, String valor) {
		String mensaxe;
		mensaxe = contexto.getResources().getString(id);
		mensaxe = mensaxe.replace("%s", valor);
		Toast.makeText(contexto.getApplicationContext(), mensaxe,
				Toast.LENGTH_SHORT).show();
	}

	/**
	 * Inicia as diferentes activity's según pulsemos o botón.
	 * 
	 * @param boton
	 */
	public void pulsarBoton(View boton) {

		switch (boton.getId()) {

		case R.id.btnPrincipalParellas:
			startActivity(new Intent(this, ActivityParellas.class));
			break;

		case R.id.btnPrincipalPreguntas:

			startActivity(new Intent(this, ActivityPreguntas.class));
			break;
		case R.id.btnPrincipalScores:

			startActivity(new Intent(this, ActivityScores.class));
			break;

		}
	}



	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_principal);

	}



	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		// Inflate the menu; this adds items to the action bar if it is present.
		getMenuInflater().inflate(R.menu.principal, menu);
		return true;
	}

}
