package com.platega.memoriae.loxica;

import java.util.ArrayList;
import java.util.Random;



public class LoxicaXogoParellas {

	private static int NUM_FILAS_NIVEL_BAIXO = 3;
	private static int NUM_FILAS_NIVEL_ALTO = 4;
	private static int NUM_COLUMNAS_NIVEL_BAIXO = 4;
	private static int NUM_COLUMNAS_NIVEL_ALTO = 4;
	
	
	/**
	 * Tempo en milesegundos
	 */
	public static final int TEMPO_CRONO=120000;
	
	
	/**
	 * Ten os id's de todas as imaxes aleatoriamente
	 * Ven a ser a matriz pero de forma unidimensacional
	 */
	public static Imaxe[][] imaxes;
	

	/**
	 * Garda os imaxes que están levantadas
	 */
	public static Imaxe[]parellaslevantadas = new Imaxe[2];

	/**
	 * Numero de parellas atopadas
	 */
	public static ArrayList<Imaxe> parellasatopadas=new ArrayList<Imaxe>();
	

	/**
	 * Engade o ID da imaxe levantada a parellaslevantadas
	 */
	public static void engadirImaxeLevantada(Imaxe imaxe){
		if (parellaslevantadas[0]==null) 
			parellaslevantadas[0]=imaxe;
		else
			parellaslevantadas[1]=imaxe;
	}
	
	/**
	 * Devolve o número de filas en función da dificultade. Por agora nivel baixo
	 */
	public static int getNumFilasXogoParellas(){
		
		  return NUM_FILAS_NIVEL_BAIXO;
	}

	/**
	 * Devolve o número de columnas en función da dificultade. Por agora nivel baixo
	 */
	public static int getNumColumnasXogoParellas(){ 
		return NUM_COLUMNAS_NIVEL_BAIXO;
	}

	/**
	* Xera un no aleatorio entre min e max [min,max)
	* @param min
	* @param max
	* @return o número aleatorio
	*/
	public static int xerarAleatorio(int min,int max) {
		Random aleat = new Random();
		return (aleat.nextInt(max-min)+min);
	}
	

}
